module pipe_eg12.
@pipelining.

export multiset_to_list(bf).

% The first argument must be bound to a multiset; returns a list
% with the same elements.
% (See the program pipe12b.P for another method.)

multiset_to_list(S, L) :- 
        insert_mset(S),
	convert(temp, [], L), !.

convert(R, Lin, Lout) :- 
                % The CORAL parser doesnt accept variables in
		% places where it expects a constant;
		% hence this kludge
	univ(T, [R,X]),
	call(T),	% T= R(X); X is bound by this call
	delete(T),
	convert(R, [X|Lin], Lout).

convert(_, L, L).

end_module.

module insert_mset.

export insert_mset(b).

insert_mset(S) :- 
	clear(check_subsumption),
	member(S, X), insert(temp(X)).

end_module.

