/*****************************************************************************/
//    CoralBreak.C
/*****************************************************************************/

#include "Globals.h"
#include "CoralBreak.h"

#include "Relation.h"

/*****************************************************************************/

int coropt;

//    Used only in DerivedRelation.C.  Move to there?
char* cordump_str;
char* cormy_str;

corbreak_info corb;

char* corScc_String = "Scc";
char* corIteration_String = "Iteration";
char* corRule_String = "Rule";

/*****************************************************************************/

static int b_flag = 0;

/*****************************************************************************/
void coral_break(char* s, int id )
{
    char str[256];
    char _Str[256];

    str[0] = '\0';
    if (id < 0)
        fprintf(corexEnv->print_file,"\nSetting up break points for module %s",s);
    else
        fprintf(corexEnv->print_file,"\nSetting up break points for %s %d",s, id);

    if (coropt) {
        if (b_flag){
            //    Send special string across
            fprintf(corexEnv->explain_fp, "explain_break(1,X).\n");
            fflush(corexEnv->explain_fp);
        }
        b_flag = 1;
    }

    fputs("\nContinue running program? (y or n) ",corexEnv->print_file);
    fscanf(corexEnv->input_file, "%s", str );
    while (str[0] != 'y') {
        fputs("\nContinue running program? (y or n) ",corexEnv->print_file);
        fscanf(corexEnv->input_file, "%s", str);
    }

    fprintf(corexEnv->print_file,"\n my_str is %s \n", cormy_str);
    sprintf(_Str,"def_new_%s(X,Y)",cormy_str);
    fprintf(corexEnv->error_file,"Relation to empty is %s\n",_Str);
 
    if (coropt) {
        //    clear the new relation
        fprintf(corexEnv->explain_fp, "rel_clear(%s).\n", _Str);
        fflush(corexEnv->explain_fp);
    }

    fputs("\n",corexEnv->print_file);
}

/*****************************************************************************/

