/*****************************************************************************/
//    ExportInfo.h
/*****************************************************************************/

#ifndef _ExportInfo_H_
#define _ExportInfo_H_

#include "SymbolArg.h"
#include "BitVector.h"
#include "Predicate.h"

/*****************************************************************************/
// An ExportInfo holds compile-time information about an
// exported predicate-adornment pair.

struct corExportInfo {
    corExportInfo *next;
    Name pred_name;
    Name adorn_symbol;
    int sequence;              // Global sequence number.
    corBitVector adornment;
    corPredicate *predicate;
};

typedef struct corExportInfo corExportInfo;

/*****************************************************************************/

#endif _ExportInfo_H_

