/*****************************************************************************/
//    ModuleExecInfo.h
/*****************************************************************************/

#ifndef _ModuleExecInfo_H_
#define _ModuleExecInfo_H_

#include "Table.h"
//#include "StorageRelation.h"
#include "RMarkArray.h"
#include "QFModuleData.h"

/*****************************************************************************/

class corStorageRelation;

/*****************************************************************************/

struct corModuleExecInfo {
    corTable* table;
    corStorageRelation* magic;
    corRMarkArray* rm_Arr;
    corQFModuleData* md;
    InterpDerivedSolver solver;
//    RMark* scan_mark;
    int    iter_number;            //    this is used by psn to determine the
                                //        iteration number of the stored
                                //        computation. On the first iteration
                                //        of an scc, the non-recursive rules
                                 //        will also be added to the recursive
                                //        rules.
    
    corModuleExecInfo(corQFModuleData *mod, corTable *tab, corStorageRelation *mag,
        InterpDerivedSolver solve)
    {
        md = mod;
        table = tab;
        magic = mag;
        solver = solve;
        rm_Arr = NULL;
        iter_number = 1;
//        scan_mark = NULL;
    }
};

/*****************************************************************************/

#endif _ModuleExecInfo_H_

