

module mod_eg5.
export t(ff).

/*  This program is stratified.  Since the only negated literal is 
congested, and it is defined in a separate module, Ordered Search 
is not used.  The answers for this program should be identical to 
the answers for the program in declne4.P; the extra facts in 
congested are irrelevant.  */

e(1,6).
e(6,7).
e(2,3).
e(2,4).
e(3,5).
e(4,6).

t(X,Y) :- t(X,Z), e(Z,Y), not congested(Z).
t(X,Y) :- e(X,Y).

end_module.

module mod_eg52.
export congested(f).


congested(10).
congested(11).
congested(12).
congested(13).
congested(15).
congested(16).
congested(17).
congested(18).
congested(19).
congested(20).
congested(21).
congested(22).
congested(23).
congested(25).
congested(26).
congested(27).
congested(28).
congested(29).
congested(30).

congested(4).
congested(Y) :- congested(X), e(X,Y).

end_module.
