// This may look like C code, but it is really -*- C++ -*-

/**********************************************************************
    File Name: The coral class
    Author:    Bill Roth(387-820-7277)
    Date:      Wed Nov 18 20:38:44 1992 @ feline
    File:      /p/coral/dev/src/clients/explain/Coral.h
    Comments:  This is the interface to coral

**********************************************************************/

class corFuncArg;
class C_ScanDesc;
class corTuple;
class corArg;
class corRelation;

class Coral {
public:
	Coral();								// call init coral

	int Consult(Tcl_Interp *interp, int argc, char **argv);
	int Parse(Tcl_Interp *interp, int argc, char **argv);
	int GetArg(Tcl_Interp *interp, char *tuple, char *index);
	int CloseScan(Tcl_Interp *interp, char *scan_id);
	int DeleteItems(Tcl_Interp *interp, int argc, char **argv);
	int GetTuple(Tcl_Interp *interp, int argc, char **argv);
	int Identify(Tcl_Interp *interp, char *arg_id);
	int OpenScan(Tcl_Interp *interp, int argc, char **argv);
	int sprint(Tcl_Interp *interp, char *parm_id);
	int ConvertList(Tcl_Interp *interp, int argc, char **argv);

  ~Coral();
};

extern Coral *coral;

/* ####################################### */

	/* Prototypes for other utilities */

int Arity(char *relname, char *predname);

int RegExScan(Tcl_Interp *interp, char *relname, char *pattern);

int DumpRel(Tcl_Interp *interp, char *dest_rel, char *src_rel,
					char *str_arity );

int EmptyRel(Tcl_Interp *interp, char *relname, char *str_arity );

char *create_entry(char *prefix, void *store);

/* ####################################### */

