#ifndef  _SUSPEND_H_
#define  _SUSPEND_H_

/*
 Suspend.h

 all the local variable originally in SemiNaive::evaluate
 the class defined is a context for the evaluation function so that
 the later can be resumed later.

*/

class corSuspendContext
{
 public:
  corTable *table;
  corSemiNaive *semi_naive;
  Name name;            // name for current workspace
  corTrail *trail;         // stack

  int conn_id;          // Connection Id this query was suspended from
  int user_id;          // Who suspended this query
  int answer;           // How many answers to give at once

  int current;
  int answer_count;
  int backtrack_index; 
  corTupleIterator **tuple_its;
  //ArgList **arglist_its;
  corStackMark stackmark0;
  corTuple **tuples;
  corRuleEnv *rule_env;
  int direction;
 
};

#endif







 
