/*****************************************************************************/
//    HandleExport.h
/*****************************************************************************/

#ifndef _HandleExport_H_
#define _HandleExport_H_

#include <string.h>
#include "Kind.h"
#include "Macro.h"

/*****************************************************************************/

class handle_export {
public:
    handle_export();

    kind* get_return_type()            { return & return_type; }
    void set_return_type(kind k)    { return_type = k; } 

    int get_num_of_args()            { return num_of_args; }
    void set_num_of_args(int i)        { num_of_args = i; } 

    void set_name(char *s)            { name = STRDUP(s); }
    void set_exported_name(char *s) { opt_exported_name = STRDUP(s); }

    char* get_name()                { return(name); }
    char* get_exported_name()        { return(opt_exported_name); }

    void put_next_arg(kind);
    kind* get_arg(int number);

private:
    kind return_type;
    kind *args_type;
    int num_of_args;
    int limit;
    char *name;
    char *opt_exported_name;
};

/*****************************************************************************/

#endif _HandleExport_H_

